Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorNthExpressions.cs	(revision 15017)
@@ -2,6 +2,8 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
@@ -17,18 +19,23 @@
     protected VectorNthExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
-      return vectorStack.IsEmpty || vectorStack.Top.Count == 0 || interpreter.IntegerStack.IsEmpty;
+    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
+      return vectorStack.IsEmpty ||
+             vectorStack.Top.Count == 0 ||
+             interpreter.IntegerStack.IsEmpty;
     }
 
     protected void Eval(
       IInternalPushInterpreter interpreter,
-      IPushStack<List<T>> vectorStack,
+      IPushStack<IReadOnlyList<T>> vectorStack,
       IPushStack<T> literalStack) {
       var vector = vectorStack.Pop();
-      var n = (int)interpreter.IntegerStack.Pop() % vector.Count;
 
-      if (n < 0) n = n + vector.Count;
-
-      literalStack.Push(vector[n]);
+      if (literalStack == interpreter.IntegerStack) {
+        var n = interpreter.IntegerStack.Top.AsInt(vector.Count);
+        literalStack.Top = vector[n];
+      } else {
+        var n = interpreter.IntegerStack.Pop().AsInt(vector.Count);
+        literalStack.Push(vector[n]);
+      }
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorOccurrenceOfExpressions.cs	(revision 15017)
@@ -17,5 +17,5 @@
     protected VectorOccurrenceOfExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       return vectorStack.IsEmpty || literalStack.IsEmpty;
     }
@@ -23,5 +23,5 @@
     protected void Eval(
       IInternalPushInterpreter interpreter,
-      IPushStack<List<T>> vectorStack,
+      IPushStack<IReadOnlyList<T>> vectorStack,
       IPushStack<T> literalStack,
       bool canOverride = false) {
@@ -34,5 +34,5 @@
       }
 
-      if (canOverride) interpreter.IntegerStack.SetTop(occurrence);
+      if (canOverride) interpreter.IntegerStack.Top = occurrence;
       else interpreter.IntegerStack.Push(occurrence);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorPushAllExpressions.cs	(revision 15017)
@@ -1,4 +1,5 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Collections.Generic;
+  using System.Linq;
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -17,11 +18,10 @@
     protected VectorPushAllExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
-      var vector = vectorStack.Pop();
-      vector.Reverse();
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
+      var vector = vectorStack.Pop().Reverse().ToArray();
       literalStack.Push(vector);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRemoveExpressions.cs	(revision 15017)
@@ -2,4 +2,6 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System.Linq;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
@@ -17,11 +19,11 @@
     protected VectorRemoveExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       return vectorStack.IsEmpty || literalStack.IsEmpty;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var literal = literalStack.Pop();
-      vectorStack.Top.RemoveAll(x => x.Equals(literal));
+      vectorStack.Top = vectorStack.Top.Where(x => !x.Equals(literal)).ToArray();
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceExpressions.cs	(revision 15017)
@@ -17,9 +17,9 @@
     protected VectorReplaceExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       return vectorStack.IsEmpty || literalStack.Count < 2;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var vector = vectorStack.Top;
       var first = literalStack.Top;
@@ -27,8 +27,11 @@
       literalStack.Remove(2);
 
+      var result = new List<T>(vector);
       for (var i = 0; i < vector.Count; i++) {
         if (vector[i].Equals(second))
-          vector[i] = first;
+          result[i] = first;
       }
+
+      vectorStack.Top = result;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceFirstExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceFirstExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReplaceFirstExpressions.cs	(revision 15017)
@@ -17,17 +17,27 @@
     protected VectorReplaceFirstExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       return vectorStack.IsEmpty || literalStack.Count < 2;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack, IPushStack<T> literalStack) {
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack) {
       var vector = vectorStack.Top;
       var first = literalStack.Top;
       var second = literalStack[1];
-      var index = vector.IndexOf(second);
       literalStack.Remove(2);
 
-      if (index >= 0)
-        vector[index] = first;
+      var index = -1;
+      for (var i = 0; i < vector.Count && index < 0; i++) {
+        if (vector[i].Equals(second)) {
+          index = i;
+          break;
+        }
+      }
+
+      if (index >= 0) {
+        var result = new List<T>(vector);
+        result[index] = first;
+        vectorStack.Top = result;
+      }
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorRestExpressions.cs	(revision 15017)
@@ -1,4 +1,6 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
   using System.Collections.Generic;
+  using System.Linq;
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -17,11 +19,28 @@
     protected VectorRestExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty || vectorStack.Top.Count < 2;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack) {
-      var result = vectorStack.Top.GetRange(1, vectorStack.Top.Count - 1);
-      vectorStack.SetTop(result);
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack) {
+      var vector = vectorStack.Top;
+      var list = vector as List<T>;
+      var newLength = vector.Count - 1;
+      if (list != null) {
+        var newTop = new T[newLength];
+        list.CopyTo(1, newTop, 0, newLength);
+        vectorStack.Top = newTop;
+        return;
+      }
+
+      var array = vector as T[];
+      if (array != null) {
+        var newTop = new T[newLength];
+        Array.Copy(array, 1, newTop, 0, newLength);
+        vectorStack.Top = newTop;
+        return;
+      }
+
+      vectorStack.Top = vector.Skip(1).ToArray();
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorReverseExpressions.cs	(revision 15017)
@@ -2,4 +2,6 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System.Linq;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
@@ -18,10 +20,10 @@
     protected VectorReverseExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IPushStack<List<T>> vectorStack) {
-      return vectorStack.IsEmpty;
+    protected bool IsNoop(IPushStack<IReadOnlyList<T>> vectorStack) {
+      return vectorStack.IsEmpty || vectorStack.Top.Count < 2;
     }
 
-    protected void Eval(IPushStack<List<T>> vectorStack) {
-      vectorStack.Top.Reverse();
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack) {
+      vectorStack.Top = vectorStack.Top.Reverse().ToArray();
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSetExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSetExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSetExpressions.cs	(revision 15017)
@@ -4,4 +4,5 @@
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
@@ -17,5 +18,5 @@
     protected VectorSetExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack, IPushStack<T> literalStack, bool isLiteralTypeInteger = false) {
+    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<T> literalStack, bool isLiteralTypeInteger = false) {
       return vectorStack.IsEmpty ||
              vectorStack.Top.Count == 0 ||
@@ -27,26 +28,28 @@
     protected void Eval(
       IInternalPushInterpreter interpreter,
-      IPushStack<List<T>> vectorStack,
+      IPushStack<IReadOnlyList<T>> vectorStack,
       IPushStack<T> literalStack,
       bool isLiteralTypeInteger = false) {
       T literal;
-      int index;
+      long x;
 
       if (isLiteralTypeInteger) {
         literal = literalStack.Top;
-        index = (int)interpreter.IntegerStack[1];
+        x = interpreter.IntegerStack[1];
         interpreter.IntegerStack.Remove(2);
       } else {
         literal = literalStack.Pop();
-        index = (int)interpreter.IntegerStack.Pop();
+        x = interpreter.IntegerStack.Pop();
       }
 
-      var vector = vectorStack.Pop();
-      index = index % vector.Count;
+      var vector = vectorStack.Top;
+      var newTop = new List<T>(vector);
+      var index = x.AsInt(vector.Count);
 
       if (index < 0)
         index *= -1;
 
-      vector[index] = literal;
+      newTop[index] = literal;
+      vectorStack.Top = newTop;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorSubExpressions.cs	(revision 15017)
@@ -3,4 +3,5 @@
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
+  using System.Linq;
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -19,9 +20,9 @@
     protected VectorSubExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty || interpreter.IntegerStack.Count < 2;
     }
 
-    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
       var first = (int)Math.Min(vectorStack.Top.Count, Math.Max(0, interpreter.IntegerStack[1]));
       var second = (int)Math.Min(vectorStack.Top.Count, Math.Max(first, interpreter.IntegerStack.Top));
@@ -31,6 +32,24 @@
         return;
 
-      var result = vectorStack.Top.GetRange(first, second - first);
-      vectorStack.SetTop(result);
+      var vector = vectorStack.Top;
+      var list = vector as List<T>;
+      var lenght = second - first;
+
+      if (list != null) {
+        var newTop = new T[lenght];
+        list.CopyTo(first, newTop, 0, lenght);
+        vectorStack.Top = newTop;
+        return;
+      }
+
+      var array = vector as T[];
+      if (array != null) {
+        var newTop = new T[lenght];
+        Array.Copy(array, first, newTop, 0, lenght);
+        vectorStack.Top = newTop;
+        return;
+      }
+
+      vectorStack.Top = vector.Skip(first).Take(lenght).ToArray();
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorTakeExpressions.cs	(revision 15017)
@@ -2,6 +2,10 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+  using System.Linq;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
@@ -17,21 +21,37 @@
     protected VectorTakeExpression(bool deserializing) : base(deserializing) { }
 
-    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
+    protected bool IsNoop(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
       return vectorStack.IsEmpty || interpreter.IntegerStack.IsEmpty;
     }
 
-    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<List<T>> vectorStack) {
-      var count = (int)interpreter.IntegerStack.Pop();
+    protected void Eval(IInternalPushInterpreter interpreter, IPushStack<IReadOnlyList<T>> vectorStack) {
 
       if (vectorStack.Top.Count == 0)
         return;
 
-      count %= vectorStack.Top.Count;
+      var count = interpreter.IntegerStack.Pop().AsInt(vectorStack.Top.Count);
 
       if (count < 0)
         count *= -1;
 
-      var result = vectorStack.Top.GetRange(0, count);
-      vectorStack.SetTop(result);
+      var vector = vectorStack.Top;
+      var list = vector as List<T>;
+
+      if (list != null) {
+        var newTop = new T[count];
+        list.CopyTo(0, newTop, 0, count);
+        vectorStack.Top = newTop;
+        return;
+      }
+
+      var array = vector as T[];
+      if (array != null) {
+        var newTop = new T[count];
+        Array.Copy(array, 0, newTop, 0, count);
+        vectorStack.Top = newTop;
+        return;
+      }
+
+      vectorStack.Top = vector.Take(count).ToArray();
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 15017)
@@ -5,4 +5,5 @@
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
   using Interpreter;
@@ -26,5 +27,5 @@
 
     protected void Eval(IPushStack<T> stack, IPushStack<long> integerStack) {
-      var index = (int)Math.Abs(integerStack.Pop() % stack.Count);
+      var index = integerStack.Pop().AsInt(stack.Count);
       stack.Push(stack[index]);
     }
@@ -96,5 +97,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.YANKDUP", StackTypes.Integer)]
+  [PushExpression(StackTypes.Exec, "EXEC.YANKDUP", StackTypes.Integer, execIn: 0)]
   public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression> {
     public ExecYankDuplicateExpression() { }
@@ -161,5 +162,5 @@
   [StorableClass]
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].YANKDUP", StackTypes.Integer)]
-  public class IntegerVectorYankDuplicateExpression : YankDuplicateExpression<List<long>> {
+  public class IntegerVectorYankDuplicateExpression : YankDuplicateExpression<IReadOnlyList<long>> {
     public IntegerVectorYankDuplicateExpression() { }
     [StorableConstructor]
@@ -177,5 +178,5 @@
   [StorableClass]
   [PushExpression(StackTypes.FloatVector, "FLOAT[].YANKDUP", StackTypes.Integer)]
-  public class FloatVectorYankDuplicateExpression : YankDuplicateExpression<List<double>> {
+  public class FloatVectorYankDuplicateExpression : YankDuplicateExpression<IReadOnlyList<double>> {
     public FloatVectorYankDuplicateExpression() { }
     [StorableConstructor]
@@ -193,5 +194,5 @@
   [StorableClass]
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].YANKDUP", StackTypes.Integer)]
-  public class BooleanVectorYankDuplicateExpression : YankDuplicateExpression<List<bool>> {
+  public class BooleanVectorYankDuplicateExpression : YankDuplicateExpression<IReadOnlyList<bool>> {
     public BooleanVectorYankDuplicateExpression() { }
     [StorableConstructor]
@@ -209,5 +210,5 @@
   [StorableClass]
   [PushExpression(StackTypes.StringVector, "STRING[].YANKDUP", StackTypes.Integer)]
-  public class StringVectorYankDuplicateExpression : YankDuplicateExpression<List<string>> {
+  public class StringVectorYankDuplicateExpression : YankDuplicateExpression<IReadOnlyList<string>> {
     public StringVectorYankDuplicateExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15017)
@@ -5,4 +5,5 @@
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
@@ -25,5 +26,5 @@
 
     protected void Eval(IPushStack<T> stack, IPushStack<long> integerStack) {
-      var index = (int)Math.Abs(integerStack.Pop() % stack.Count);
+      var index = integerStack.Pop().AsInt(stack.Count);
       stack.Yank(index);
     }
@@ -95,5 +96,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.YANK", StackTypes.Integer)]
+  [PushExpression(StackTypes.Exec, "EXEC.YANK", StackTypes.Integer, execIn: 0)]
   public class ExecYankExpression : YankExpression<Expression> {
     public ExecYankExpression() { }
@@ -160,5 +161,5 @@
   [StorableClass]
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].YANK", StackTypes.Integer)]
-  public class IntegerVectorYankExpression : YankExpression<List<long>> {
+  public class IntegerVectorYankExpression : YankExpression<IReadOnlyList<long>> {
     public IntegerVectorYankExpression() { }
     [StorableConstructor]
@@ -176,5 +177,5 @@
   [StorableClass]
   [PushExpression(StackTypes.FloatVector, "FLOAT[].YANK", StackTypes.Integer)]
-  public class FloatVectorYankExpression : YankExpression<List<double>> {
+  public class FloatVectorYankExpression : YankExpression<IReadOnlyList<double>> {
     public FloatVectorYankExpression() { }
     [StorableConstructor]
@@ -192,5 +193,5 @@
   [StorableClass]
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].YANK", StackTypes.Integer)]
-  public class BooleanVectorYankExpression : YankExpression<List<bool>> {
+  public class BooleanVectorYankExpression : YankExpression<IReadOnlyList<bool>> {
     public BooleanVectorYankExpression() { }
     [StorableConstructor]
@@ -208,5 +209,5 @@
   [StorableClass]
   [PushExpression(StackTypes.StringVector, "STRING[].YANK", StackTypes.Integer)]
-  public class StringVectorYankExpression : YankExpression<List<string>> {
+  public class StringVectorYankExpression : YankExpression<IReadOnlyList<string>> {
     public StringVectorYankExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/CharExtentions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/CharExtentions.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/CharExtentions.cs	(revision 15017)
@@ -0,0 +1,17 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Extensions {
+  public static class CharExtentions {
+    public static string Printify(this char c) {
+      switch (c) {
+        case '\0': return "\\0";
+        case '\a': return "\\a";
+        case '\b': return "\\b";
+        case '\f': return "\\f";
+        case '\n': return "\\n";
+        case '\r': return "\\r";
+        case '\t': return "\\t";
+        case '\v': return "\\v";
+        default: return c.ToString();
+      }
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/CollectionExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/CollectionExtensions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/CollectionExtensions.cs	(revision 15017)
@@ -12,4 +12,22 @@
       return source[x];
     }
+
+    public static int HashCode<T>(this IReadOnlyList<T> source) {
+      var hash = 19 * 31 + typeof(T).FullName.GetHashCode();
+
+      for (var i = 0; i < source.Count; i++)
+        hash = hash * 31 + source[i].GetHashCode();
+
+      return hash;
+    }
+
+    public static int HashCode<T>(this IEnumerable<T> source) {
+      var hash = 19 * 31 + typeof(T).FullName.GetHashCode();
+
+      foreach (var item in source)
+        hash = hash * 31 + item.GetHashCode();
+
+      return hash;
+    }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/LongExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/LongExtensions.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/LongExtensions.cs	(revision 15017)
@@ -0,0 +1,9 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Extensions {
+  public static class LongExtensions {
+    public static int AsInt(this long value, int length) {
+      return (int)Math.Abs(value % length);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/RandomExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/RandomExtensions.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/RandomExtensions.cs	(revision 15017)
@@ -0,0 +1,20 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Extensions {
+  using HeuristicLab.Core;
+
+  public static class RandomExtensions {
+    /// <summary>
+    /// Generates a random biased towards min
+    /// <see href="https://gamedev.stackexchange.com/questions/116832/random-number-in-a-range-biased-toward-the-low-end-of-the-range">Source</see>
+    /// </summary>
+    /// <param name="min">Minimum random int</param>
+    /// <param name="max">Maximum random int</param>
+    /// <param name="biasLevel">The bigger this values is, the bigger is the probability that min will be generated</param>
+    /// <param name="random">Random number generater</param>
+    /// <returns></returns>
+    public static int NextBiased(this IRandom random, int min, int max, double biasLevel) {
+      return (int)(min + (max - min) * Math.Pow(random.NextDouble(), biasLevel));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/CodeGeneratorUtils.cs	(revision 15017)
@@ -96,4 +96,19 @@
             : new CharPushExpression(ercOptions.CharErcOptions.GetErcValue(random));
 
+        case StackTypes.IntegerVector:
+          return ercOptions.IntegerVectorErcOptions == null || !ercOptions.IntegerVectorErcOptions.IsEnabled
+            ? Noop
+            : new IntegerVectorPushExpression(ercOptions.IntegerVectorErcOptions.GetErcValue(random).Select(i => (long)i).ToList());
+
+        case StackTypes.FloatVector:
+          return ercOptions.FloatVectorErcOptions == null || !ercOptions.FloatVectorErcOptions.IsEnabled
+            ? Noop
+            : new FloatVectorPushExpression(ercOptions.FloatVectorErcOptions.GetErcValue(random));
+
+        case StackTypes.StringVector:
+          return ercOptions.StringVectorErcOptions == null || !ercOptions.StringVectorErcOptions.IsEnabled
+            ? Noop
+            : new StringVectorPushExpression(ercOptions.StringVectorErcOptions.GetErcValue(random));
+
         default:
           return Noop;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15017)
@@ -34,9 +34,13 @@
 
       foreach (StackTypes type in Enum.GetValues(stackTypesType)) {
+        if (!interpreter.Stacks.ContainsKey(type)) continue;
+
         var stackName = Enum.GetName(stackTypesType, type);
         var stack = interpreter.Stacks[type];
 
-        if (stack.IsEmpty || !stack.IsEnabled) return;
-        Console.WriteLine("--------- {0} ---------\n{1}\n", stackName, stack);
+        if (stack.IsEmpty || !stack.IsEnabled) continue;
+
+        var stackString = string.Join(" ", interpreter.StringifyStack(type).Reverse());
+        Console.WriteLine("--------- {0} ---------\n{1}\n", stackName, stackString);
       }
 
